package tp1;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLClassLoader;

public class ServeurDeClassPoint{
 
  static ClassLoader c1;
  static Class ptClass;
  static String url;
  static String className;
  
  public static Point createClassPoint(Point tmp) throws Exception{
    if (ptClass==null){reloadImpl();}
    Point newPt=(Point)ptClass.newInstance();
    if (tmp!=null){ 
      newPt.initialize(tmp);
    }
    return newPt;
  }
  
  public static synchronized void reloadImpl() throws Exception{
    setProperties();
    URL[] urls=new URL[]{new URL(url)};
    c1=new URLClassLoader(urls);
    ptClass=c1.loadClass(className);
  }
  
  private static void setProperties() throws Exception {
   URL u=new URL("file:params");
   BufferedReader is=new BufferedReader(new InputStreamReader(u.openStream()));
   url=is.readLine(); 
   className=is.readLine();
   System.out.println("Les paramtres sont : "+url+className);
  }
  	
}
 
