package useechoservice;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;

import provideservice.EchoServiceImpl;

public class UseEchoService implements BundleActivator {
  public void start(BundleContext bc) throws Exception {
    ServiceReference sr=bc.getServiceReference("provideservice.service.EchoService");
    if (sr!=null){
      provideservice.service.EchoService callEcho=(provideservice.service.EchoService)bc.getService(sr);
      if (callEcho !=null){
        System.out.println(callEcho.echo("coucou"));
      }else{
        System.out.println("Erreur, Impossible d'obtenir l'implantation");
      }
    }else{
      System.out.println("Erreur, impossible d'obtenir le service");
    }
  }


  public void stop(BundleContext bc){
    System.out.println("Au revoir");
  }
}
  
