package insa.webcam.dummyservice;
import insa.webcam.ifc.JMStudioIfc;

import java.util.Properties;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class WebcamSimuActivator implements BundleActivator {

  BundleContext bc;
  String version = "1.0.1";

  public void start(BundleContext context) throws Exception {
    System.out.println("Webcam simulator service started : " + version);
    bc = context;
		WebcamSimulator webcamSimu = new WebcamSimulator(context);
		Properties props = new Properties();
		props.put("location", "localhost");		
    bc.registerService(JMStudioIfc.class.getName(), webcamSimu, props);
  }

  public void stop(BundleContext context) throws Exception {
    System.out.println("Webcam simulator service stopped : " + version);
  }
}
